﻿using Kivii.Funq;
using Kivii.Lims.Entities;
using Kivii.Linq;
using Kivii.Third.Scjgj.Entities;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Third.Scjgj
{
    internal static class Extensions
    {
        internal static PlanDetail ConvertTo(this PlanDetail item, IDbConnection conn = null)
        {
            PlanDetail rtns = new PlanDetail();
            bool connDispose = false;
            if (conn == null)
            {
                connDispose = true;
                var factory = Kivii.Linq.LinqUtils.GetLinqConnectionFactory("Data Source=218.94.159.228:8083/sjdb;User Id=sjqzsfzydbl;Password=admin;", "Oracle");
                conn = factory.OpenDbConnection();
            }
            switch (item.CHECK_STATE)
            {
                case "1":
                    rtns = item.ConvertToNormal(conn);
                    break;
                case "2":
                    rtns = item.ConvertToReject(conn);
                    break;
                case "3":
                    rtns = item.ConvertToUnable(conn);
                    break;
                case "4":
                    rtns = item.ConvertToFinished(conn);
                    break;
                case "5":
                    rtns = item.ConvertToMarket(conn);
                    break;
                case "6":
                    rtns = item.ConvertToOther(conn);
                    break;
                case null:
                    rtns = item.ConvertToCommerce(conn);
                    break;
                default:
                    break;
            }
            if (connDispose) { conn.Dispose(); }

            return rtns;
        }
        /// <summary>
        /// 正常抽样
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail ConvertToNormal(this PlanDetail item, IDbConnection conn)
        {
            if (item.CARY_ID != null)
            {
                item.Cary = GetCaryById(conn, item.CARY_ID);
            }

            if (item.PRO_ID != null)
            {
                item.ProduceUnit = GetProduceUnitById(conn, item.PRO_ID);
            }

            if (item.EXEC_ID != null)
            {
                item.ExecUint = GetExecUintById(conn, item.EXEC_ID);
            }
            return item;
        }
        /// <summary>
        /// 拒绝采样
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail ConvertToReject(this PlanDetail item, IDbConnection conn)
        {
            return item;
        }
        /// <summary>
        /// 无法抽样
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail ConvertToUnable(this PlanDetail item, IDbConnection conn)
        {
            return item;
        }
        /// <summary>
        /// 成品油抽样
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail ConvertToFinished(this PlanDetail item, IDbConnection conn)
        {
            return item;
        }
        /// <summary>
        /// 市场抽样
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail ConvertToMarket(this PlanDetail item, IDbConnection conn)
        {
            if (item.CARY_ID != null)
            {
                item.Cary = GetCaryById(conn, item.CARY_ID);
            }

            if (item.EXEC_ID != null)
            {
                item.ExecUint = GetExecUintById(conn, item.EXEC_ID);
            }

            if (item.PRO_ID != null)
            {
                item.ProduceUnit = GetProduceUnitById(conn, item.PRO_ID);
            }
            return item;
        }
        /// <summary>
        /// 其他抽样
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail ConvertToOther(this PlanDetail item, IDbConnection conn)
        {
            if (item.CARY_ID != null)
            {
                item.Cary = GetCaryById(conn, item.CARY_ID);
            }

            if (item.EXEC_ID != null)
            {
                item.ExecUint = GetExecUintById(conn, item.EXEC_ID);
            }

            if (item.OTHER_ID != null)
            {
                item.Other = GetOtherById(conn, item.OTHER_ID);
            }
            return item;
        }
        /// <summary>
        /// 电商买样
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail ConvertToCommerce(this PlanDetail item, IDbConnection conn)
        {
            if (item.CARY_ID != null)
            {
                item.Cary = GetCaryById(conn, item.CARY_ID);
            }

            if (item.EXEC_ID != null)
            {
                item.ExecUint = GetExecUintById(conn, item.EXEC_ID);
            }

            if (item.EC_ID != null)
            {
                item.EcPlatform = GetEcPlatformById(conn, item.EC_ID);
            }

            if (item.PRO_ID != null)
            {
                item.ProduceUnit = GetProduceUnitById(conn, item.PRO_ID);
            }
            return item;
        }

        /// <summary>
        /// 受检单位信息
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="caryId"></param>
        /// <returns></returns>
        internal static Cary GetCaryById(IDbConnection conn, int? caryId)
        {
            if (caryId == null) return null;

            var query = conn.From<Cary>();
            query.Where(o => o.ID == caryId);
            return conn.Single(query);
        }
        /// <summary>
        /// 生产单位信息
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="proId"></param>
        /// <returns></returns>
        internal static ProduceUnit GetProduceUnitById(IDbConnection conn, int? proId)
        {
            if (proId == null) return null;

            var query = conn.From<ProduceUnit>();
            query.Where(o => o.ID == proId);
            return conn.Single(query);
        }
        /// <summary>
        /// 抽样机构信息
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="execId"></param>
        /// <returns></returns>
        internal static ExecUint GetExecUintById(IDbConnection conn, int? execId)
        {
            if (execId == null) return null;

            var query = conn.From<ExecUint>();
            query.Where(o => o.ID == execId);
            return conn.Single(query);
        }
        /// <summary>
        /// 电商单位信息
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="ecId"></param>
        /// <returns></returns>
        internal static EcPlatform GetEcPlatformById(IDbConnection conn, int? ecId)
        {
            if (ecId == null) return null;

            var query = conn.From<EcPlatform>();
            query.Where(o => o.EC_ID == ecId);
            return conn.Single(query);
        }
        /// <summary>
        /// 其他来源单位信息
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="otherId"></param>
        /// <returns></returns>
        internal static Other GetOtherById(IDbConnection conn, int? otherId)
        {
            if (otherId == null) return null;

            var query = conn.From<Other>();
            query.Where(o => o.ID == otherId);
            return conn.Single(query);
        }
    }
}
